# sol2 3.5.0 documentation

## tutorial

### Search the Documentation

# tutorial

Take some time to learn the framework with these tutorials. But, if you need to get going FAST, try using the quick ‘n’ dirty approach and your browser’s / editors search function. It will also serve you well to look at all the examples, which have recently gotten a bit of an overhaul to contain more relevant working examples and other advanced tricks that you can leverage to have a good time!

sol Tutorial

- tutorial: quick ‘n’ dirty
  - asserts / prerequisites
  - opening a state
  - using sol2 on a lua_State*
  - running lua code
  - running lua code (low-level)
  - passing arguments to scripts
  - transferring functions (dumping bytecode)
  - set and get variables
  - tables
  - make tables
  - functions
  - self call
  - multiple returns from lua
  - multiple returns to lua
  - C++ classes from C++
  - C++ classes put into Lua
  - namespacing
  - there is a LOT more
- getting started
- integrating into existing code
- variables
  - reading
  - writing
- functions and You
  - Setting a new function
  - Getting a function from Lua
  - Multiple returns to and from Lua
  - Any return to and from Lua
- C++ in Lua
- ownership
  - object ownership
  - pointer ownership
  - ephermeal (proxy) objects
- adding your own types